/////////////////////////////////////////////////////////////////////////////
// MainFrm.cpp : implementation of the CMainFrame class
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// includes
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "HexEditCtrl.h"
#include "MainFrm.h"
#include "SetHighlighingDlg.h"
#include "HexEditCtrlView.h"
#include "TestCtrlDlg.h"


/////////////////////////////////////////////////////////////////////////////
// defines
/////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// class CMainFrame
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_HIGHLIGHTSECTION, OnViewHighlightsection)
	ON_COMMAND(ID_VIEW_READONLY, OnViewReadonly)
	ON_COMMAND(ID_VIEW_SETADRESSLENGTH_2BYTES, OnViewSetadresslength2bytes)
	ON_COMMAND(ID_VIEW_SETADRESSLENGTH_4BYTES, OnViewSetadresslength4bytes)
	ON_COMMAND(ID_VIEW_SETADRESSLENGTH_6BYTES, OnViewSetadresslength6bytes)
	ON_COMMAND(ID_VIEW_SETADRESSLENGTH_8BYTES, OnViewSetadresslength8bytes)
	ON_COMMAND(ID_VIEW_SETBYTESLINE_128BYTES, OnViewSetbytesline128bytes)
	ON_COMMAND(ID_VIEW_SETBYTESLINE_16BYTES, OnViewSetbytesline16bytes)
	ON_COMMAND(ID_VIEW_SETBYTESLINE_32BYTES, OnViewSetbytesline32bytes)
	ON_COMMAND(ID_VIEW_SETBYTESLINE_4BYTES, OnViewSetbytesline4bytes)
	ON_COMMAND(ID_VIEW_SETBYTESLINE_64BYTES, OnViewSetbytesline64bytes)
	ON_COMMAND(ID_VIEW_SETBYTESLINE_8BYTES, OnViewSetbytesline8bytes)
	ON_COMMAND(ID_VIEW_SETBYTESLINE_AUTO, OnViewSetbyteslineAuto)
	ON_COMMAND(ID_VIEW_SHOW_ADDRESS, OnViewShowAddress)
	ON_COMMAND(ID_VIEW_SHOWBINARY, OnViewShowbinary)
	ON_COMMAND(ID_TESTCONTROLS, OnTestcontrols)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	return TRUE;
}

void CMainFrame::OnViewHighlightsection() 
{
	UINT nBeg, nEnd;
	CSetHighlighingDlg cDlg;
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	pView->GetHexEditCtrl().GetHighlighted(nBeg, nEnd);
	cDlg.SetStartAdr(nBeg);
	cDlg.SetEndAdr(nEnd);
	cDlg.DoModal();	
	nBeg = cDlg.GetStartAdr();
	nEnd = cDlg.GetEndAdr();
	if( (nBeg != -1) && (nEnd != -1) ) {
		pView->GetHexEditCtrl().SetHighlighted(nBeg, nEnd);
	} else {
		pView->GetHexEditCtrl().SetHighlighted(NOSECTION_VAL, NOSECTION_VAL);
	}
}

void CMainFrame::OnViewReadonly() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	BOOL bCheck = pMenu->GetMenuState(ID_VIEW_READONLY, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_READONLY, bCheck ? MF_UNCHECKED : MF_CHECKED );
	pView->GetHexEditCtrl().SetReadonly(bCheck==0);
}

void CMainFrame::OnViewSetadresslength2bytes() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_2BYTES, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_4BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_6BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_8BYTES, MF_UNCHECKED);
	pView->GetHexEditCtrl().SetAddressSize(2);
}

void CMainFrame::OnViewSetadresslength4bytes() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_2BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_4BYTES, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_6BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_8BYTES, MF_UNCHECKED);
	pView->GetHexEditCtrl().SetAddressSize(4);
}

void CMainFrame::OnViewSetadresslength6bytes() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_2BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_4BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_6BYTES, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_8BYTES, MF_UNCHECKED);
	pView->GetHexEditCtrl().SetAddressSize(6);
}

void CMainFrame::OnViewSetadresslength8bytes() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_2BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_4BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_6BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETADRESSLENGTH_8BYTES, MF_CHECKED);
	pView->GetHexEditCtrl().SetAddressSize(8);
}

void CMainFrame::OnViewSetbytesline128bytes() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_128BYTES, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_64BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_32BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_16BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_8BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_4BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_AUTO, MF_UNCHECKED);
	pView->GetHexEditCtrl().SetBytesPerRow(128);
}

void CMainFrame::OnViewSetbytesline16bytes() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_128BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_64BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_32BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_16BYTES, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_8BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_4BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_AUTO, MF_UNCHECKED);
	pView->GetHexEditCtrl().SetBytesPerRow(16);
}

void CMainFrame::OnViewSetbytesline32bytes() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_128BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_64BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_32BYTES, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_16BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_8BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_4BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_AUTO, MF_UNCHECKED);
	pView->GetHexEditCtrl().SetBytesPerRow(32);
}

void CMainFrame::OnViewSetbytesline4bytes() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_128BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_64BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_32BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_16BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_8BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_4BYTES, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_AUTO, MF_UNCHECKED);
	pView->GetHexEditCtrl().SetBytesPerRow(4);
}

void CMainFrame::OnViewSetbytesline64bytes() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_128BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_64BYTES, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_32BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_16BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_8BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_4BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_AUTO, MF_UNCHECKED);
	pView->GetHexEditCtrl().SetBytesPerRow(64);
}

void CMainFrame::OnViewSetbytesline8bytes() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_128BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_64BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_32BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_16BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_8BYTES, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_4BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_AUTO, MF_UNCHECKED);
	pView->GetHexEditCtrl().SetBytesPerRow(8);
}

void CMainFrame::OnViewSetbyteslineAuto() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_128BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_64BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_32BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_16BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_8BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_4BYTES, MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SETBYTESLINE_AUTO, MF_CHECKED);
	pView->GetHexEditCtrl().SetBytesPerRow(8, true);
}

void CMainFrame::OnViewShowAddress() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	BOOL bCheck = pMenu->GetMenuState(ID_VIEW_SHOW_ADDRESS, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SHOW_ADDRESS, bCheck ? MF_UNCHECKED : MF_CHECKED );
	pView->GetHexEditCtrl().SetShowAddress(bCheck==0);
}

void CMainFrame::OnViewShowbinary() 
{
	CHexEditCtrlView *pView = DYNAMIC_DOWNCAST(CHexEditCtrlView, GetActiveView());
	ASSERT(pView != NULL);	
	CMenu *pMenu = GetMenu();
	ASSERT(pMenu != NULL);

	BOOL bCheck = pMenu->GetMenuState(ID_VIEW_SHOWBINARY, MF_CHECKED);
	pMenu->CheckMenuItem(ID_VIEW_SHOWBINARY, bCheck ? MF_UNCHECKED : MF_CHECKED );
	pView->GetHexEditCtrl().SetShowAscii(bCheck==0);
}

void CMainFrame::OnTestcontrols() 
{
	CTestCtrlDlg cDlg;
	cDlg.DoModal();
}


#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG
