/////////////////////////////////////////////////////////////////////////////
// TestCtrlDlg.cpp : implementation file
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// includes
/////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "HexEditCtrl.h"
#include "TestCtrlDlg.h"
#include "SetHighlighingDlg.h"


/////////////////////////////////////////////////////////////////////////////
// defines
/////////////////////////////////////////////////////////////////////////////
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// class CTestCtrlDlg
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(CTestCtrlDlg, CDialog)
	//{{AFX_MSG_MAP(CTestCtrlDlg)
	ON_BN_CLICKED(IDC_BTN_HIGHLIGHT1, OnBtnHighlight1)
	ON_BN_CLICKED(IDC_BTN_HIGHLIGHT2, OnBtnHighlight2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CTestCtrlDlg::CTestCtrlDlg(CWnd* pParent)
	: CDialog(CTestCtrlDlg::IDD, pParent), 
	m_pHexEditSingleLine2(NULL), m_pHexEditMultiLine2(NULL)

{
	//{{AFX_DATA_INIT(CTestCtrlDlg)
	//}}AFX_DATA_INIT
}


void CTestCtrlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestCtrlDlg)
	DDX_Control(pDX, IDC_HED_SL1, m_cHexEditSingleLine1);
	DDX_Control(pDX, IDC_HED_ML1, m_cHexEditMultiline1);
	//}}AFX_DATA_MAP
}

void CTestCtrlDlg::OnBtnHighlight1() 
{
	UINT nBeg, nEnd;
	CSetHighlighingDlg cDlg;

	m_cHexEditSingleLine1.GetHighlighted(nBeg, nEnd);
	cDlg.SetStartAdr(nBeg);
	cDlg.SetEndAdr(nEnd);
	cDlg.DoModal();	
	nBeg = cDlg.GetStartAdr();
	nEnd = cDlg.GetEndAdr();
	if( (nBeg != NOSECTION_VAL) && (nEnd != NOSECTION_VAL) ) {
		m_cHexEditSingleLine1.SetHighlighted(nBeg, nEnd);
	} else {
		m_cHexEditSingleLine1.SetHighlighted(NOSECTION_VAL, NOSECTION_VAL);
	}
}

void CTestCtrlDlg::OnBtnHighlight2() 
{
	ASSERT(m_pHexEditMultiLine2 != NULL);
	UINT nBeg, nEnd;
	CSetHighlighingDlg cDlg;

	m_pHexEditMultiLine2->GetHighlighted(nBeg, nEnd);
	cDlg.SetStartAdr(nBeg);
	cDlg.SetEndAdr(nEnd);
	cDlg.DoModal();	
	nBeg = cDlg.GetStartAdr();
	nEnd = cDlg.GetEndAdr();
	if( (nBeg != NOSECTION_VAL) && (nEnd != NOSECTION_VAL) ) {
		m_pHexEditMultiLine2->SetHighlighted(nBeg, nEnd);
	} else {
		m_pHexEditMultiLine2->SetHighlighted(NOSECTION_VAL, NOSECTION_VAL);
	}
}

BOOL CTestCtrlDlg::OnInitDialog() 
{	
	BYTE bTest[256];
	CDialog::OnInitDialog();

	// try to connect to the other two controls
	m_pHexEditSingleLine2 = DYNAMIC_DOWNCAST(CHexEditBase, GetDlgItem(IDC_HED_SL2));
	ASSERT(m_pHexEditSingleLine2 != NULL);
	m_pHexEditMultiLine2 = DYNAMIC_DOWNCAST(CHexEditBase, GetDlgItem(IDC_HED_ML2));
	ASSERT(m_pHexEditMultiLine2  != NULL);

	// prepare testdata
	for(int i=0; i<256; ++i) {
		bTest[i] = (BYTE)i;
	}

	// initialise data
	
	// via DDX connected
	m_cHexEditSingleLine1.SetData(bTest, 16);
	m_cHexEditMultiline1.SetAddressSize(3, false);
	m_cHexEditMultiline1.SetShowAddress(true, false);
	m_cHexEditMultiline1.SetBytesPerRow(8, true, false);
	m_cHexEditMultiline1.SetData(bTest, 256);
	
	// self created true the own window-procedure
	m_pHexEditSingleLine2->SetData(bTest, 16);
	m_pHexEditMultiLine2->SetBytesPerRow(8, true, false);
	m_pHexEditMultiLine2->SetData(bTest, 256);
	
	return TRUE;
}
